/*
*
*   DatePicker JavaScript Library
*   Author： meiya
*   Date：2018年8月
*
*/

// 使用格式：
// new DatePicker(
//     'DatePicker',    ( 必填 )函数名称
//     {
//         update: [    ( 可选 ) 从当前时间开始更新到某年某月
//             1,
//             3
//         ],
//         specialDate: { ( 可选 )设置特殊日期
//             1:{      1月
//                 2: 'HTML' 2 号
//                 ……
//             },
//             7:{      7月
//                 12: 'HTML' 12 号
//                 ……
//             },
//             ……
//         },
//         callback: function( ret ){   ( 必填 )交互回调
//             if( ret.eventType === 'show'){
//                 element.innerHTML = ret.data;
//             }else{
//                 element.innerHTML = ret.time;
//             }
//         }
//     }
// )


var DatePicker = function() {
    var oldendD = null;
    var oldstartD = null;

    var curr_year = new Date().getFullYear();
    var curr_month = new Date().getMonth()+1;
    var curr_day = new Date().getDate();
    var clickindex = 0;
    var startcheck = 0;
    var startobj = null;
    var endcheck = 0;
    var endobj = null;
    var inputstartobj = null;
    var inputendobj = null;
    function init(trendsName, config) {
        window[ trendsName ] = this;
        Date.prototype._start = function() {
            var start = new Date(this),
                end = new Date(this);
            start.setDate(1);
            end.setDate(1);
            end.setMonth(end.getMonth() - 1 );
            return { len: start.getDay(), end: Math.abs( ( start - end ) / 86400000) };
        };
        Date.prototype._end = function() {
            var start = new Date(this),
                end = new Date(this);
            start.setDate(1);
            end.setDate(1);
            end.setMonth(end.getMonth() + 1);
            return { date: start, len: (end - start) / 86400000 };
        };
        Date.prototype.setFormat = function( num ) {
            return num < 10 ? '0'+num: num;
        };
        this.trendsName = trendsName;
        this.config = config;
        this.vDate = new Date;
        this.update( config.update && config.update[0], config.update && config.update[1] );
    }
    init.prototype = {
        update: function(y, m) {
            var con = [],
                D = this.vDate,
                _this = this,
                _html = '<table cellpadding=0 cellspacing=2>';

            y && D.setYear(D.getFullYear() + y);
            // m && D.setMonth(D.getMonth() + m);
            m && D.setMonth(D.getMonth() + m,1); //因为当前月份是31天，而设置的月份小于31天，就会把日期顺延。在setMonth的说明

            var year = D.getFullYear(),
            month = D.getMonth() + 1,
            date = D.getDate();
            var start = D._start();
            for (var i = start.len - 1; i >= 0; i--){
                con.push('<td> <span style="color:#CFCFCF"></span></td>');//隐藏 1号前的日期
                // con.push('<td> <span style="color:#CFCFCF">'+( start.end - i )+'</span></td>');
                // con.push('<td class="noborder">'+( start.end - i )+'</td>');
            }

            var end = D._end();
            // console.log(date + "-" + curr_month +"-" + curr_year);

            for (var i = 0; i < end.len; i++){
                var specialDate = '';
                if( this.config.specialDate ){
                    if( Object.keys( this.config.specialDate ).indexOf( month.toString() ) != -1 ){
                        if( this.config.specialDate[month][ i + 1 ] ){
                            specialDate = this.config.specialDate[month][ i + 1 ];
                        }
                    }
                }

                // if (month == 1 && i == 0) {
                //   specialDate = "<div class='specialDate' style='color:red;' >元旦</div>";
                // }
                // else if (month == 10 && i == 0) {
                //   specialDate = "<div class='specialDate' style='color:red;' >国庆节</div>";
                // }
                var monthStr =  month < 10 ? ('0' + month) : month;
                var dayStr = (i + 1) < 10 ? ('0' + (i + 1)) : (i + 1)



                // console.log(this.config.mindate.substring(8,2));
                // 1 最小时间限制 && i < parseInt(this.config.mindate.substring(8,10)
                if (month == curr_month && year == curr_year && checkDate(year+'-'+monthStr+'-'+dayStr,this.config.mindate )) {
                  if (date == curr_day && month == curr_month && year == curr_year && date == i+1) {
                    specialDate = "<div class='specialDate' >今天</div>";
                    con.push('<td id="'+year+'-'+ monthStr +'-'+ dayStr +'"> <span style="color:#e0e0e0">'+specialDate +( i + 1 )+'</span></td>');
                  }else {
                    con.push('<td id="'+year+'-'+ monthStr +'-'+ dayStr +'"> <span style="color:#e0e0e0">'+( i + 1 )+'</span></td>');
                  }

                }
                else if (checkDate(year+'-'+monthStr+'-'+dayStr,this.config.mindate )) {
                   con.push('<td id="'+year+'-'+ monthStr +'-'+ dayStr +'"> <span style="color:#e0e0e0">'+( i + 1 )+'</span></td>');
                }
                else if (this.config.godate !="" && this.config.returndate !="" && month == parseInt(this.config.godate.substring(5,7)) && month == parseInt(this.config.returndate.substring(5,7)) &&
                year == parseInt(this.config.godate.substring(0,4)) && year == parseInt(this.config.returndate.substring(0,4)) &&
                i+1 == parseInt(this.config.godate.substring(8,10)) && i+1 == parseInt(this.config.returndate.substring(8,10))) {
                  // 2 往返
                  specialDate = "<div class='selectDate' style='color:#fff;' >往/返</div>";
                  if (con.length % 7 == 0 || con.length % 7 == 6) {
                    con.push('<td id="'+this.config.godate+'" style="background-color: #13a1ff;color:#167df2;" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                  }
                  else {
                    con.push('<td id="'+this.config.godate+'" style="background-color: #13a1ff" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                  }

                }
                else if (this.config.godate !="" && month == parseInt(this.config.godate.substring(5,7)) && year == parseInt(this.config.godate.substring(0,4)) && i+1 == parseInt(this.config.godate.substring(8,10))) {
                  // 3 去程绘制
                  specialDate = "<div class='selectDate' style='color:#fff;' >去程</div>";
                  if (con.length % 7 == 0 || con.length % 7 == 6) {
                    con.push('<td id="'+this.config.godate+'" style="background-color: #13a1ff;color:#167df2;" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                  }
                  else {
                    con.push('<td id="'+this.config.godate+'" style="background-color: #13a1ff;" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                  }

                }
                else if (this.config.returndate !="" && month == parseInt(this.config.returndate.substring(5,7)) && year == parseInt(this.config.returndate.substring(0,4)) && i+1 == parseInt(this.config.returndate.substring(8,10))) {
                  // 4 回程绘制
                  specialDate = "<div class='selectDate' style='color:#fff;' >回程</div>";
                  if (con.length % 7 == 0 || con.length % 7 == 6) {
                    con.push('<td id="'+this.config.returndate+'" style="background-color: #13a1ff;color:#167df2;" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                  }
                  else {
                    con.push('<td id="'+this.config.returndate+'" style="background-color: #13a1ff" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                  }

                }
                else if (date == curr_day && month == curr_month && year == curr_year && date == i+1) {
                  //今天绘制
                  specialDate = "<div class='specialDate' >今天</div>";
                  con.push('<td style="" id="'+year+'-'+ monthStr +'-'+ dayStr +'" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                }else {
                  //其他日期绘制
                  if (con.length % 7 == 0 || con.length % 7 == 6) {
                    //比较绘制时间与去程时间和回程时间 是否在选择的时间内
                    if (checkDate(this.config.godate,year+'-'+ monthStr +'-'+ dayStr) && checkDate(year+'-'+ monthStr +'-'+ dayStr,this.config.returndate)) {
                      con.push('<td style="background-color:#cbeaff; color:#167df2;" id="'+year+'-'+ monthStr +'-'+ dayStr +'" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\'  tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                    }else {
                      con.push('<td style="color:#167df2" id="'+year+'-'+ monthStr +'-'+ dayStr +'" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\'  tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                    }



                  }
                  else {
                    if (checkDate(this.config.godate,year+'-'+ monthStr +'-'+ dayStr) && checkDate(year+'-'+ monthStr +'-'+ dayStr,this.config.returndate)) {
                      con.push('<td style="background-color:#cbeaff; color:#333;" id="'+year+'-'+ monthStr +'-'+ dayStr +'" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\'  tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                    }
                    else {
                      con.push('<td style="" id="'+year+'-'+ monthStr +'-'+ dayStr +'" currday="'+(i + 1)+'" currtime =\'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\'  tapmode onclick="' + this.trendsName + '.fillInput({ el: this , date: \'' + new Date( ( end.date.getTime() + ( i * ( 3600 * 24 ) * 1000 ) ) ).getTime() + '\' })">'+specialDate+'' + (i + 1) + '</td>');
                    }
                  }

                }

            }
            var toend = con.length % 7;
                for (var i = 0; i < 7 - toend; i++){
                    // con.push('<td > <span style="color:#CFCFCF">'+( i + 1 )+'</span></td>');
                    con.push('<td > <span style="color:#CFCFCF"></span></td>');//隐藏当月末最后一天后的日期
                }
                for (var i = 0; i < con.length; i++){
                    _html += (i == 0 ? '<tr>': i % 7 == 0 ? '</tr><tr>': '') +  con[i] + (i == con.length - 1 ? '</tr>': '');
                }
            if (m == 11) {
              this.createBox( '<div class="title" id="'+year+'-'+D.setFormat( month )+'">'+( year+' 年 '+D.setFormat( month )+' 月' )+'</div>'+_html ,true);
            }else {
              this.createBox( '<div class="title" id="'+year+'-'+D.setFormat( month )+'">'+( year+' 年 '+D.setFormat( month )+' 月' )+'</div>'+_html ,false);
            }

        },
        fillInput: function( d ) {
            var obj = d.el;
            var curr_days= obj.getAttribute("currday");
            var curr_time = obj.getAttribute("currtime");
            inputstartobj = document.getElementById(this.config.godate)
            inputendobj = document.getElementById(this.config.returndate)


            //点击的是出发时间 选择2次
            if (this.config.selindex == 0) {
                if (clickindex == 0) {
                  clickindex = clickindex + 1;
                  startcheck = curr_days;
                  startobj = obj;

                  //将出发时间和结束时间之间的日期背景去除
                  var alld =  getAllDate(this.config.godate,this.config.returndate);
                  alld.shift();
                  alld.pop();
                  setOldColor(alld,null)




                  //输入去程时间
                  if (inputstartobj !=undefined) {
                    inputstartobj.innerHTML = inputstartobj.getAttribute("currday")
                    inputstartobj.style.backgroundColor = "white"
                  }
                  //输入回程时间
                  if (inputendobj !=undefined) {
                    inputendobj.innerHTML = inputendobj.getAttribute("currday")
                    inputendobj.style.backgroundColor = "white"
                  }

                  if (obj.style.backgroundColor == "#13a1ff") {
                    obj.innerHTML =  "<div class='selectDate' style='color:#fff;' >往/返</div>"+curr_days;
                  }else {
                    obj.style.backgroundColor="#13a1ff"
                    obj.setAttribute("currtime",curr_time);
                    obj.innerHTML =  "<div class='selectDate' style='color:#fff;' >去程</div>"+curr_days;
                  }

                  api.toast({
                      msg: '请选择返程日期',
                      duration: 1500,
                      location: 'bottom'
                  });
                }
                else if (clickindex == 1) {
                  clickindex = clickindex + 1;
                  endcheck = curr_days;
                  endobj = obj;
                  if (obj.style.backgroundColor == "#13a1ff") {
                    obj.setAttribute("currtime",curr_time);
                    obj.innerHTML =  "<div class='selectDate' style='color:#fff;'>往/返</div>"+curr_days;
                  }
                  else if (formatDateTime(startobj.getAttribute("currtime")) == formatDateTime(endobj.getAttribute("currtime"))) {
                    obj.setAttribute("currtime",curr_time);
                    obj.innerHTML =  "<div class='selectDate' style='color:#fff;'>往/返</div>"+curr_days;
                  }else {
                    obj.setAttribute("currtime",curr_time);
                    obj.style.backgroundColor="#13a1ff"
                    obj.innerHTML =  "<div class='selectDate' style='color:#fff;'>回程</div>"+curr_days;
                  }

                }

                if(startobj != null && endobj != null){
                    var startobj_time = startobj.getAttribute("currtime");
                    var endobj_time = endobj.getAttribute("currtime");
                    if(startobj_time > endobj_time){
                      startobj.innerHTML =  "<div class='selectDate' style='color:#fff;'>回程</div>"+startobj.getAttribute("currday");
                      startobj.setAttribute("currtime",endobj_time);
                      endobj.innerHTML =  "<div class='selectDate' style='color:#fff;'>去程</div>"+endobj.getAttribute("currday");
                      endobj.setAttribute("currtime",startobj_time);
                    }
                }

                if (clickindex == 1) {
                  // api.toast({
                  //     msg: '请选择回程',
                  //     duration: 2000,
                  //     location: 'bottom'
                  // });

                }

                if (clickindex > 1) {
                    //绘制背景
                    var alld =  getAllDate(formatDateTime(startobj.getAttribute("currtime")),formatDateTime(endobj.getAttribute("currtime")));
                    alld.shift();
                    alld.pop();
                    // console.log(alld);
                    setColor(alld,null)
                    this.config.callback( {eventType: 'click', el: d.el, startime: formatDateTime(startobj.getAttribute("currtime")),endtime:formatDateTime(endobj.getAttribute("currtime"))} );
                }

                // if (clickindex == 2) {
                //   this.config.callback( {eventType: 'click', el: d.el, time: d.date} );
                // }
            }
            else if (this.config.selindex == 1) {//点击的是结束时间  最小时间应该为出发时间  选择一次
              // if (clickindex == 0) {//第一次
                clickindex = clickindex + 1;
                startcheck = curr_days;
                startobj = inputstartobj;
                endobj = obj;
                if (inputendobj !=undefined) {
                  inputendobj.innerHTML = inputendobj.getAttribute("currday")
                  inputendobj.style.backgroundColor = "white"
                }

                //去程
                document.getElementById(formatDateTime(startobj.getAttribute("currtime"))).innerHTML =  "<div class='selectDate' style='color:#fff;'>去程</div>"+
                (formatDateTime(startobj.getAttribute("currtime")).substring(8,10).substring(0,1) == "0" ? formatDateTime(startobj.getAttribute("currtime")).substring(9,10) : formatDateTime(startobj.getAttribute("currtime")).substring(8,10));
                document.getElementById(formatDateTime(startobj.getAttribute("currtime"))).style.backgroundColor="#13a1ff";

                if (obj.style.backgroundColor == "#13a1ff" && oldendD != formatDateTime(endobj.getAttribute("currtime"))) {
                  obj.setAttribute("currtime",curr_time);
                  obj.innerHTML =  "<div class='selectDate' style='color:#fff;'>往/返</div>"+curr_days;
                }
                else if (formatDateTime(startobj.getAttribute("currtime")) == formatDateTime(endobj.getAttribute("currtime"))) {
                  obj.style.backgroundColor="#13a1ff"
                  obj.setAttribute("currtime",curr_time);
                  obj.innerHTML =  "<div class='selectDate' style='color:#fff;'>往/返</div>"+curr_days;
                }
                else {
                  obj.setAttribute("currtime",curr_time);
                  obj.style.backgroundColor="#13a1ff"
                  obj.innerHTML =  "<div class='selectDate' style='color:#fff;'>回程</div>"+curr_days;
                }

              // }


              if (inputendobj !=undefined && inputendobj != null) {
                  if (inputendobj.getAttribute("currtime") != undefined && inputendobj.getAttribute("currtime") != null) {
                    oldendD = formatDateTime(inputendobj.getAttribute("currtime"));
                  }

              }

              var alld =  getAllDate(formatDateTime(startobj.getAttribute("currtime")),formatDateTime(endobj.getAttribute("currtime")));
              alld.shift();
              alld.pop();
              if (oldendD != formatDateTime(endobj.getAttribute("currtime")) && oldendD != formatDateTime(startobj.getAttribute("currtime"))) {
                setColor(alld,oldendD)
              }else {
                setColor(alld,null)
              }

              if (oldendD != null && oldendD != formatDateTime(endobj.getAttribute("currtime"))) {
                var oldalld =  getAllDate(formatDateTime(endobj.getAttribute("currtime")),oldendD)
                oldalld.shift();
                oldalld.pop();
                if(checkDate(formatDateTime(endobj.getAttribute("currtime")),oldendD) && oldendD != formatDateTime(startobj.getAttribute("currtime")))
                {
                  setOldColor(oldalld,oldendD)
                }else {
                  setOldColor(oldalld,null)
                }
              }



              // oldendD = formatDateTime(endobj.getAttribute("currtime"));


              if (clickindex > 0) {
                  this.config.callback( {eventType: 'click', el: d.el, startime: formatDateTime(startobj.getAttribute("currtime")),endtime:formatDateTime(endobj.getAttribute("currtime"))} );//this.config.godate
              }
            }







        },
        createBox: function(html,isend) {
            this.config.callback( {eventType: 'show', data: html, isend:isend} );


        }
    }
    return init;
}();

//获取两个日期之间的所有日期
function getAllDate(start,end) {
  var date_all=[],i=0;
  // var start = "2016-12-27";
  // var end = "2017-01-05";
  var startTime = getDate(start);
  var endTime = getDate(end);
  while((endTime.getTime()-startTime.getTime())>=0){
    var year = startTime.getFullYear();
    var month = (startTime.getMonth()+1).toString().length==1?"0"+(startTime.getMonth()+1).toString():(startTime.getMonth()+1).toString();
    var day = startTime.getDate().toString().length==1?"0"+startTime.getDate():startTime.getDate();
    // var month = (startTime.getMonth()+1).toString();
    // var day = startTime.getDate();

    date_all[i]=year+"-"+month+"-"+day;
    startTime.setDate(startTime.getDate()+1);
    i+=1;
  }
  return date_all

}

function getDate(datestr){
  var temp = datestr.split("-");
  var date = new Date(temp[0],temp[1]-1,temp[2]);
  return date;
}

function formatDateTime(timeValue) {
    var date = new Date(parseInt(timeValue));
    var y = date.getFullYear();
    var m = date.getMonth() + 1;
    m = m < 10 ? ('0' + m) : m;
    var d = date.getDate();
    d = d < 10 ? ('0' + d) : d;
    // var h = date.getHours();
    // h = h < 10 ? ('0' + h) : h;
    // var minute = date.getMinutes();
    // var second = date.getSeconds();
    // minute = minute < 10 ? ('0' + minute) : minute;
    // second = second < 10 ? ('0' + second) : second;
    // return y + '-' + m + '-' + d + ' ' + h + ':' + minute + ':' + second;
    return y + '-' + m + '-' + d;
};

//比较大小
function checkDate(start,end) {

  var startTime = getDate(start);
  var endTime = getDate(end);
  if ((endTime.getTime()-startTime.getTime())>=0) {
    return true;
  }else {
    return false;
  }
}

function setColor(alld,oldendD) {
  if (alld.length > 0 && oldendD != null) {
    document.getElementById(oldendD).style.backgroundColor="#fff";
    document.getElementById(oldendD).innerHTML = oldendD.substring(8,10).substring(0,1) == "0" ?  oldendD.substring(9,10) : oldendD.substring(8,10);
  }
  for (var i = 0; i < alld.length; i++) {
    // console.log(alld[i]);//2018-08-08
    document.getElementById(alld[i]).style.backgroundColor="#cbeaff";
    document.getElementById(alld[i]).innerHTML =  alld[i].substring(8,10).substring(0,1) == "0" ?  alld[i].substring(9,10) : alld[i].substring(8,10);
  }
}

function setOldColor(oldalld,oldendD) {
  if (oldendD != null) {
    document.getElementById(oldendD).style.backgroundColor="#fff";
    document.getElementById(oldendD).innerHTML =  oldendD.substring(8,10).substring(0,1) == "0" ?  oldendD.substring(9,10) : oldendD.substring(8,10);
  }
  for (var i = 0; i < oldalld.length; i++) {
    // console.log(oldalld[i]);//2018-08-08
    document.getElementById(oldalld[i]).style.backgroundColor="#fff";
    document.getElementById(oldalld[i]).innerHTML =  oldalld[i].substring(8,10).substring(0,1) == "0" ?  oldalld[i].substring(9,10) : oldalld[i].substring(8,10);
  }
}
