
//使用方法：timeChange(parseInt(data.CreateDate.substring(6,19)))
//时间戳转换日期 (yyyy-MM-dd HH:mm:ss)
       function formatDateTime(timeValue) {
           var date = new Date(timeValue);
           var y = date.getFullYear();
           var m = date.getMonth() + 1;
           m = m < 10 ? ('0' + m) : m;
           var d = date.getDate();
           d = d < 10 ? ('0' + d) : d;
           var h = date.getHours();
           h = h < 10 ? ('0' + h) : h;
           var minute = date.getMinutes();
           var second = date.getSeconds();
           minute = minute < 10 ? ('0' + minute) : minute;
           second = second < 10 ? ('0' + second) : second;
           return y + '-' + m + '-' + d + ' ' + h + ':' + minute + ':' + second;
       };

       //判断传入日期是否为昨天
       function isYestday(timeValue) {
           var date = (new Date()); //当前时间
           var today = new Date(date.getFullYear(), date.getMonth(), date.getDate()).getTime(); //今天凌晨
           var yestday = new Date(today - 24 * 3600 * 1000).getTime();
           return timeValue < today && yestday <= timeValue;
       };

       //判断传入日期是否属于今年
       function isYear (timeValue) {
           var takeNewYear = formatDateTime(new Date()).substr(0,4); //当前时间的年份
           var takeTimeValue = formatDateTime(timeValue).substr(0,4); //传入时间的年份
           return takeTimeValue == takeNewYear;
       }

       //60000 1分钟
       //3600000 1小时
       //86400000 24小时
       //对传入时间进行时间转换
       function timeChange(timeValue) {

           var timeNew = Date.parse(new Date()); //当前时间
           var timeDiffer = timeNew - timeValue; //与当前时间误差
           // console.log(timeValue);
           // console.log();
           var returnTime = '';

           if(timeDiffer <= 60000) { //一分钟内

               var returnTime = '刚刚';

           } else if(timeDiffer > 60000 && timeDiffer < 3600000) { //1小时内

               var returnTime = Math.floor(timeDiffer / 60000 )+ '分钟前';

           } else if(timeDiffer >= 3600000 && timeDiffer < 86400000 && isYestday(timeValue) === false) { //今日

              //  var returnTime = formatDateTime(timeValue).substr(11,5);
               var returnTime = Math.floor(timeDiffer / 60000 / 60 )+ '小时前';

           } else if(timeDiffer > 3600000 && isYestday(timeValue) === true) { //昨天

               var returnTime = '昨天'+formatDateTime(timeValue).substr(11,5);

           } else if (timeDiffer > 86400000 && isYestday(timeValue) === false && isYear (timeValue) === true){  //今年

               var returnTime = formatDateTime(timeValue).substr(5,11);

           } else if (timeDiffer > 86400000 && isYestday(timeValue) === false && isYear (timeValue) === false) { //不属于今年

               var returnTime = formatDateTime(timeValue).substr(0,10);

           }

           return returnTime;
       }


       //获取开始日期的前后日期 结束日期限制  为空则不限制 返回4个时间节点  开始时间默认为第三节点
       function getShoppingDate(start,end){
         var backDateArr=[];
         var nowDate = getDateStr_AddDay(0);
         // 1 开始时间在今天到3天后之间
         if (compareDateInclude(nowDate,start) && compareDateInclude(start,getDateStr_AddDay(2))) {
           for (var i = 0; i < 4; i++) {
             var isUsed = true;
             if (end) {
               if (compareDate(end,getDateStr_AddDay(i))) {
                 isUsed = false;
               }
             }
             backDateArr.push({
               isUsed: isUsed,
               date:getDateStr_AddDay(i),
               week:getMyDay(getDateStr_AddDay(i))
             })
           }
         } else{
           // 2 开始时间在3天之后
           for (var i = 0; i < 4; i++) {
             var isUsed = true;
             if (end) {
               if (compareDate(end,getDateStr_AddDayByStart(start,i-2))) {
                 isUsed = false;
               }
             }
             backDateArr.push({
               isUsed: isUsed,
               date:getDateStr_AddDayByStart(start,i-2),
               week:getMyDay(getDateStr_AddDayByStart(start,i-2))
             })
           }
         }
         console.log(JSON.stringify(backDateArr));
         return backDateArr;
       }

       //获取开始日期的前后日期 结束日期限制  为空则不限制 返回5个时间节点  开始时间默认为第三节点
       function getShoppingDate_1(start,end){
        var backDateArr=[];
        var nowDate = getDateStr_AddDay(0);
        // 1 开始时间在今天到3天后之间
        if (compareDateInclude(nowDate,start) && compareDateInclude(start,getDateStr_AddDay(2))) {
          for (var i = 0; i < 5; i++) {
            var isUsed = true;
            if (end) {
              if (compareDate(end,getDateStr_AddDay(i))) {
                isUsed = false;
              }
            }
            backDateArr.push({
              isUsed: isUsed,
              date:getDateStr_AddDay(i),
              week:getMyDay(getDateStr_AddDay(i))
            })
          }
        } else{
          // 2 开始时间在3天之后
          for (var i = 0; i < 5; i++) {
            var isUsed = true;
            if (end) {
              if (compareDate(end,getDateStr_AddDayByStart(start,i-2))) {
                isUsed = false;
              }
            }
            backDateArr.push({
              isUsed: isUsed,
              date:getDateStr_AddDayByStart(start,i-2),
              week:getMyDay(getDateStr_AddDayByStart(start,i-2))
            })
          }
        }
        console.log(JSON.stringify(backDateArr));
        return backDateArr;
      }

       //比较大小str 不含相等情况
    	 function compareDate(start,end) {
      	  var startTime = getDate(start);
      	  var endTime = getDate(end);
      	  if ((endTime.getTime()-startTime.getTime())>0) {
      		    return true;
      	  }else {
      		    return false;
      	  }
    	 }
    	 //比较大小str 含=
    	 function compareDateInclude(start,end) {
      	  var startTime = getDate(start);
      	  var endTime = getDate(end);
      	  if ((endTime.getTime()-startTime.getTime())>=0) {
      		    return true;
      	  }else {
      		    return false;
      	  }
    	 }

       //时间格式化11compareDate
    	 function getDate(datestr){
      	  var temp = datestr.split("-");
      	  var date = new Date(temp[0],temp[1]-1,temp[2]);
      	  return date;
     	 }

       // 周几
       function getMyDay(date) {
           if (date == getDateStr(0)) {
               return '今天';
           }else {
               var week;
               var d = new Date(date);
               if (d.getDay() == 0) week = "周日"
               if (d.getDay() == 1) week = "周一"
               if (d.getDay() == 2) week = "周二"
               if (d.getDay() == 3) week = "周三"
               if (d.getDay() == 4) week = "周四"
               if (d.getDay() == 5) week = "周五"
               if (d.getDay() == 6) week = "周六"
               return week;
           }
       }

       //获取距离日期 如 2019/05/30
       function getDateStr(AddDayCount) {
           var dd = new Date();
           dd.setDate(dd.getDate()+AddDayCount);
           var y = dd.getFullYear();
           var m = (dd.getMonth()+1) < 10 ? "0"+(dd.getMonth()+1):(dd.getMonth()+1);
           var d = dd.getDate() < 10 ? "0" + dd.getDate():dd.getDate();
           return y + "/" + m + "/" + d;
       }

       //获取距离日期 如 2019-05-30
       function getDateStr_AddDay(AddDayCount) {
            var dd = new Date();
            dd.setDate(dd.getDate() + AddDayCount);
            var y = dd.getFullYear();
            var m = (dd.getMonth() + 1) < 10 ? "0" + (dd.getMonth() + 1) : (dd.getMonth() + 1);
            var d = dd.getDate() < 10 ? "0" + dd.getDate() : dd.getDate()
            return y + "-" + m + "-" + d
       }

       //获取指定日期的距离日期 如 2019-05-30
    	 function getDateStr_AddDayByStart(StartDate,AddDayCount) {
    	    var dd = new Date(StartDate);
    	    dd.setDate(dd.getDate() + AddDayCount);
    	    var y = dd.getFullYear();
    	    var m = (dd.getMonth() + 1) < 10 ? "0" + (dd.getMonth() + 1) : (dd.getMonth() + 1);
    	    var d = dd.getDate() < 10 ? "0" + dd.getDate() : dd.getDate()
    	    return y + "-" + m + "-" + d
    	 }

       function replaceAllV1(str,g1,g2){
      		if(str!=null)
      		  str = str.replace(g1,g2)
      		return str;
      	}


       function checkTel(tel){
        //  var re=/^(13[0-9]{9})|(15[89][0-9]{8})$/;
         var re=/^1[0-9]{10}$/;
         if(!re.test(tel)){
            api.toast({
                msg: '请输入正确的手机号码！',
                duration: 2000,
                location: 'bottom'
            });
            return false;
          }
          else {
            return true;
          }
       }

       function isMobile(tel){
        //  var re=/^(13[0-9]{9})|(15[89][0-9]{8})$/;
         var re=/^((\\+86)|(86))?[1][3456789]\d{9}$/;
         if(!re.test(tel)){
            return false;
          }
          else {
            return true;
          }
       }

       function checkTel30(tel){
         var re=/^\d{5,30}$/;
         if(!re.test(tel)){
            api.toast({
                msg: '请输入正确的手机号码！',
                duration: 2000,
                location: 'bottom'
            });
            return false;
          }
          else {
            return true;
          }
       }


       function isMobile30(tel){
         var re=/^\d{5,30}$/;
         if(!re.test(tel)){
            return false;
          }
          else {
            return true;
          }
       }



       function checkEmail(email) {
        //  var re =/[\w!#$%&'*+/=?^_`{|}~-]+(?:\.[\w!#$%&'*+/=?^_`{|}~-]+)*@(?:[\w](?:[\w-]*[\w])?\.)+[\w](?:[\w-]*[\w])?/
         var re = /^([\w_-])+(\.[\w_-]+)*@([\w_-])+((\.[\w_-]+)+)$/;
         if(!re.test(email)){
            api.toast({
                msg: '请输入正确的邮箱！',
                duration: 2000,
                location: 'bottom'
            });
            return false;
          }
          else {
            return true;
          }
       }

       function isEmail(email){
        //  var re =/[\w!#$%&'*+/=?^_`{|}~-]+(?:\.[\w!#$%&'*+/=?^_`{|}~-]+)*@(?:[\w](?:[\w-]*[\w])?\.)+[\w](?:[\w-]*[\w])?/
         var re = /^([\w_-])+(\.[\w_-]+)*@([\w_-])+((\.[\w_-]+)+)$/;
         if(!re.test(email)){
            return false;
          }
          else {
            return true;
          }
       }


       function isCardNo(card)  {
          // 身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X
          var re = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
              if(!re.test(card))
              {
                api.toast({
                    msg: '身份证输入不合法',
                    duration: 2000,
                    location: 'bottom'
                });
                return false;
              }
              else {
                return true;
              }
       }

       //只能输入金额
       function bindKeyEvent(obj){
           obj.keyup(function () {
               var reg = $(this).val().match(/\d+\.?\d{0,2}/);
                var txt = '';
                if (reg != null) {
                   txt = reg[0];
                }
                $(this).val(txt);
            }).change(function () {
               $(this).keypress();
                var v = $(this).val();
                if (/\.$/.test(v))
                {
                    $(this).val(v.substr(0, v.length - 1));
               }
            });
        }


       //打开通讯录 obj=id
       function openPhoneList(obj){
         api.openContacts(function(ret,err) {
           if(ret.status){
               var phonestr = ret.phone;
               phonestr = phonestr.replace(' ', '').replace(' ', '').replace(' ', '').replace('-', '').replace('-', '').replace('-', '').replace('+86', '')
               if (phonestr) {
                 $api.byId(obj).value = phonestr;
               }
           }else{
               if (err) {
                 api.alert({msg:err.msg});
               } else {
                 api.alert({msg:'读取通讯录权限被禁止了,请在手机系统设置通讯录或联系人权限'});
               }

           };

         });
       }

       //千分位
       function numberformat(val){
          isFuShu = false;//是否负数
          if (typeof(val) != "string") {
            val = val+'';
          }

          if (val == 0) {
            val = "0.00"
          }
          else if (val < 0) {
            isFuShu = true;
            val = val.split("-")[1]
          }

          var source = val.split(".");//按小数点分成2部分
          source[0] = source[0].replace(new RegExp('(\\d)(?=(\\d{3})+$)','ig'),"$1,");//只将整数部分进行都好分割
          var result = source.join(".");//再将小数部分合并进来

          if (isFuShu) {
            result = "-" + result;
          }
          return result;
      }

      //相差几个月 new Date('2019-10-10')
      function getMonthBetween(startDate,endDate){
          var num=0;
          var year=endDate.getFullYear()-startDate.getFullYear();
          num+=year*12;
          var month=endDate.getMonth()-startDate.getMonth();
          num+=month;
          var day=endDate.getDate()-startDate.getDate();
          if(day>0){
          　　num+=1;
          }else if(day<0){
            num-=1
          }
          return num;
      }

      // js浮点型加法  js计算bug
      function accAdd(arg1,arg2){
        var r1,r2,m;
        try{r1=arg1.toString().split(".")[1].length}catch(e){r1=0}
        try{r2=arg2.toString().split(".")[1].length}catch(e){r2=0}
        m=Math.pow(10,Math.max(r1,r2))
        return ((arg1*m+arg2*m)/m).toFixed(2);
      }
      // js浮点型除法
      function accDiv(arg1,arg2){
         var t1=0,t2=0,r1,r2;
         try{t1=arg1.toString().split(".")[1].length}catch(e){}
         try{t2=arg2.toString().split(".")[1].length}catch(e){}
         with(Math){
         r1=Number(arg1.toString().replace(".",""))
         r2=Number(arg2.toString().replace(".",""))
         return (r1/r2)*pow(10,t2-t1);
        }
      }
      // js浮点型乘法
      function accMul(arg1,arg2)
      {
         var m=0,s1=arg1.toString(),s2=arg2.toString();
         try{m+=s1.split(".")[1].length}catch(e){}
         try{m+=s2.split(".")[1].length}catch(e){}
         return Number(s1.replace(".",""))*Number(s2.replace(".",""))/Math.pow(10,m)
      }
      // js浮点型减法
      function accSubtr(arg1,arg2){
         var r1,r2,m,n;
         try{r1=arg1.toString().split(".")[1].length}catch(e){r1=0}
         try{r2=arg2.toString().split(".")[1].length}catch(e){r2=0}
         m=Math.pow(10,Math.max(r1,r2));
         //动态控制精度长度
         n=(r1>=r2)?r1:r2;
         return ((arg1*m-arg2*m)/m).toFixed(n);
      }

      //保留2位小数 不管小数位是否为0
      function toFixed(value, d) {
            var s = value + "";
            if (!d) d = 0;
            if (s.indexOf(".") == -1) s += ".";
            s += new Array(d + 1).join("0");
            if (new RegExp("^(-|\\+)?(\\d+(\\.\\d{0," + (d + 1) + "})?)\\d*$").test(s)) {
                var s = "0" + RegExp.$2, pm = RegExp.$1, a = RegExp.$3.length, b = true;
                if (a == d + 2) {
                    a = s.match(/\d/g);
                    if (parseInt(a[a.length - 1]) > 4) {
                        for (var i = a.length - 2; i >= 0; i--) {
                            a[i] = parseInt(a[i]) + 1;
                            if (a[i] == 10) {
                                a[i] = 0;
                                b = i != 1;
                            } else break;
                        }
                    }
                    s = a.join("").replace(new RegExp("(\\d+)(\\d{" + d + "})\\d$"), "$1.$2");

                }
                if (b) s = s.substr(1);
                return (pm + s).replace(/\.$/, "");
            }
            return value + "";
      }

      //保留2位小数
      function parseNum2(value){
        var _value = value;
        if(_value != 0 || _value != "0"){
          _value = parseFloat(parseFloat(value).toFixed(2))
        }
        return _value;
      }

      //正则验证用户密码  提交前1
      function checkUserPassWordByRegex(value) {
        //var re = /^(?![0-9]+$)(?![a-z]+$)(?![A-Z]+$)(?![~!@#$%^&*/\\]+$)(?!([0-9]|[a-z])+$)(?!([0-9]|[A-Z])+$)(?!([0-9]|[~!@#$%^&*/\\])+$)(?!([a-z]|[A-Z])+$)(?!([a-z]|[~!@#$%^&*/\\])+$)(?!([A-Z]|[~!@#$%^&*/\\])+$)([0-9]|[A-Z]|[a-z]|[~!@#$%^&*/\\]){8,20}$/;
        var re = /(?!^(\d+|[a-zA-Z]+|[~!@#_*%/.+:;=]+)$)^[\w~:;=!]{8,20}$/;
        var re_0 = /(.)\1{6}/;
        if (!re.test(value)) {
            return false;
        } else {
          if (re_0.test(value)) {
            return false;
          } else {
            return true;
          }
        }
      }

      //正则验证用户密码  提交时2
      function checkUserPassWordByRegex2(value) {
        //var re = /^(?=([A-Za-z0-9]|[~@#_*%/.+:;=!]){8,20}$)(?!\w*?1234\w*?)(?!\w*?abcd\w*?)(?!\w*?qwer\w*?)(?!\w*?4321\w*?)(?!\w*?(?<six>\w)\k<six>{5}\w*?)/;
        //var re = /^(?=([A-Za-z0-9]|[~@#_*%/.+:;=!]){8,20}$)(?!\w*?1234\w*?)(?!\w*?abcd\w*?)(?!\w*?qwer\w*?)(?!\w*?4321\w*?)(?!\w*(.)\1{6}\w*?)/;
        var re = /(?!^(\d+|[a-zA-Z]+|[~!@#_*%/.+:;=]+)$)(?!\w*?1234\w*?)(?!\w*?abcd\w*?)(?!\w*?qwer\w*?)(?!\w*?4321\w*?)^[\w~!@#_*%/.+:;=]{8,20}/;
        if (!re.test(value)) {
            return false;
        } else {
            return true;
        }
      }

      //正则验证用户密码 连续的密码
      function checkContinuousPassWordByRegex(value) {
        var re = /^(?!\w*?1234\w*?)(?!\w*?abcd\w*?)(?!\w*?qwer\w*?)(?!\w*?4321\w*?)/;
        if (!re.test(value)) {
            return false;
        } else {
            return true;
        }
      }
      //正则验证用户密码 连续的密码 2
      function checkContinuousPassWordByRegexType(value, retype) {
        var re_0 = /^(?!\w*?1234\w*?)(?!\w*?abcd\w*?)(?!\w*?qwer\w*?)(?!\w*?4321\w*?)/;
        if(retype == 1){
          re_0 = /^(?!\w*?1234\w*?)/;
        }
        else if(retype == 2){
          re_0 = /^(?!\w*?abcd\w*?)/;
        }else if(retype == 3){
          re_0 = /^(?!\w*?qwer\w*?)/;
        }else if(retype == 4){
          re_0 = /^(?!\w*?4321\w*?)/;
        }
        if (!re_0.test(value)) {
            return false;
        } else {
            return true;
        }
      }

      //计算时间间隔
      function getDayDiff(date1,date2){
        // console.log(date1);
        // console.log(date2);
        if (typeof date1 == 'string')
            date1 = new Date(date1.replace(/-/g, '/'));
        if (typeof date2 == 'string')
            date2 = new Date(date2.replace(/-/g, '/'));
        var milSecondes = date2 - date1;
        return parseInt(milSecondes / (1000 * 60 * 60 * 24));
      }

      
      //保留两位小数，第三位直接舍去 
      function keepTwoDecimal(num) {
        var self = this;
        if (num > 0) {
            return this.accDiv(parseInt(self.accMul(self.accAdd(num, 0.00999999), 100)), 100);
        }
        else {
            return this.accDiv(parseInt(self.accMul(num, 100)), 100);
        }
     }

     //分钟数转换成x小时x分钟
     function toHourMinute(val) {
        if (!val) {
            return '';
        }
        const int = parseInt(val, 10);
        const hours = parseInt(int / (60), 10);
        const minutes = int % (60);
        //const leaveTime = int % (60);
        //const minutes = parseInt(leaveTime / 60, 10);
        return hours + 'h' + minutes + 'm';
    }
    //分钟数转换成x小时x分钟
    function toHourMinuteSimple(val) {
      if (!val) {
          return '';
      }
      const int = parseInt(val, 10);
      const hours = parseInt(int / (60), 10);
      const minutes = int % (60);
      //const leaveTime = int % (60);
      //const minutes = parseInt(leaveTime / 60, 10);
      if (hours > 0 && minutes > 0) {
        return hours + '小时' + minutes + '分钟';
      } 
      else if(hours > 0){
        return hours + '小时';
      }
      else {
        return minutes + '分钟';
      }
      
   }
    //获取两个时间差  1.SEC:相差秒数，2.MIN:相差分钟数，3.HH:相差小时数，4.HH:MIN: SEC:相差 “时：分：秒” 数，5.DD:相差天数，6.MM:相差月数，7.YY：相差年数       
    function dateTimeDifference (oneTime, twoTime, stype) {
        if (oneTime == null || oneTime == "") return 0;
        if (twoTime == null || twoTime == "") return 0;
        var myoneTime = new Date(oneTime);
        var mytwoTime = new Date(twoTime);
        if (myoneTime == null || myoneTime == "") return 0;
        if (mytwoTime == null || mytwoTime == "") return 0;
        if (myoneTime > mytwoTime) return 0;

        if (stype == "SEC") {
            return (mytwoTime - myoneTime) / 1000 + "sec";
        } else if (stype == "MIN") {
            return ((mytwoTime - myoneTime) / 1000) / 60;
        } else if (stype == "HH") {
            return (((mytwoTime - myoneTime) / 1000) / 60) / 60 + "h";
        } else if (stype == "DD") {
            return ((((mytwoTime - myoneTime) / 1000) / 60) / 60) / 24;
        } else if (stype == "MM") {
            return (((((mytwoTime - myoneTime) / 1000) / 60) / 60) / 24) / 31 + "M";
        } else if (stype == "YY") {
            return ((((((mytwoTime - myoneTime) / 1000) / 60) / 60) / 24) / 31) / 365 + "Y";
        } else if (stype == "HH:MIN:SEC") {
            var seconds = (mytwoTime - myoneTime) / 1000;
            if (seconds <= 60) {
                return seconds + "sec";
            } else if (60 < seconds && seconds <= 3600) {
                return Math.floor(seconds / 60) + "小时" + (seconds % 60) + "分";
            } else if (3600 < seconds && seconds <= 216000) {
                return Math.floor(seconds / 3600) + "小时" + Math.floor((seconds % 3600) / 60) + "分" + ((seconds % 3600) % 60) + "秒";
            }
        } else {
            return mytwoTime - myoneTime;
        }
    }

    function dateTimeDif (myoneTime, mytwoTime) {
        var seconds = (mytwoTime - myoneTime) / 1000;
        if (seconds <= 60) {
            return seconds + "sec";
        } else if (60 < seconds && seconds <= 3600) {
            return Math.floor(seconds / 60) + "小时" + (seconds % 60) + "分";
        } else if (3600 < seconds && seconds <= 216000) {   //216000 = 2.5day
            return Math.floor(seconds / 3600) + "小时" + Math.floor((seconds % 3600) / 60) + "分";// + ((seconds % 3600) % 60) + "秒";
        }

    }


    function getWeek (date) {
        if (typeof date == 'string') {
            date = new Date(date.replace(/-/g, '/'));
        }
        var week = '';
        switch (date.getDay()) {
            case 1:
                week = '星期一';
                break;
            case 2:
                week = '星期二';
                break;
            case 3:
                week = '星期三';
                break;
            case 4:
                week = '星期四';
                break;
            case 5:
                week = '星期五';
                break;
            case 6:
                week = '星期六';
                break;
            case 0:
                week = '星期日';
                break;
        }
        return week;
    }

    function getTimeSectionOfTheTimeRange (time) {
        //获取时间所属时间段:凌晨(0:00-6:00)0~360;上午(6:00-12:00)360~720;下午(12:00-18:00)720~1080;晚上(18:00-24:00)1080~1440
        if (time == null || time.length == 0) return;
        var timeArr = time.toString().split(":");
        if (timeArr.length != 2) return;
        //计算time的小时和分钟数总和
        var timeSum = parseInt(timeArr[0]) * 60 + parseInt(timeArr[1]);
        var timeQuantum = '';
        if (timeSum >= 0 && timeSum < 360) {
            timeQuantum = '1'; //凌晨
        } else if (timeSum >= 360 && timeSum < 720) {
            timeQuantum = '2'; //上午
        } else if (timeSum >= 720 && timeSum < 1080) {
            timeQuantum = '3'; //下午
        } else if (timeSum >= 1080 && timeSum < 1440) {
            timeQuantum = '4'; //晚上
        } else return;
        return timeQuantum;
    }

  

    function getSSDateEN (data) {
      var self = this;
      if (data == null || data.length != 10) return '*****';
      return data.substr(8, 2) + setting.shortEnglishMonthArray[data.substr(5, 2) - 1];
    }

    //将时间转换成分钟数
    function getTimeMinite(time) {
      //00:30=30、02:00=120、01:30=90
      if (time == null || time.length == 0) return;
      var timeArr = time.toString().split(":");
      if (timeArr.length != 2) return;
      //计算time的小时和分钟数总和
      var timeSum = parseInt(timeArr[0]) * 60 + parseInt(timeArr[1]);
      return timeSum;
	  }
    
    function dateTimeDiff(myoneTime, mytwoTime) {
      var seconds = (mytwoTime - myoneTime) / 1000;
      if (seconds <= 60) {
        return seconds + "sec";
      } else if (60 < seconds && seconds <= 3600) {
        return Math.floor(seconds / 60) + "h" + (seconds % 60) + "m";
      } else if (3600 < seconds && seconds <= 216000) {   //216000 = 2.5day
        return Math.floor(seconds / 3600) + "h" + Math.floor((seconds % 3600) / 60) + "m";// + ((seconds % 3600) % 60) + "秒";
      }
  
    }

    function minutesToTimeStr(minutesTotal) {
      var hours = parseInt(accDiv(minutesTotal, 60)),
          minutes = parseInt(minutesTotal % 60);
      var durationStr = hours + 'h';
      if (minutes > 0) {
          durationStr += minutes + 'm';
      }
      return durationStr;
  }


    var setting = {
      shortEnglishMonthArray: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
    }

    //匹配正整数
    function isNumber(s) {
      var reg = /^[0-9]\d*$/;
      if(reg.test(s)) {
          return true;
      }
      return false;
  }

  function isInList(list, t) {
    for (var i = 0; i < list.length; i++) {
        if (list[i] === t)
            return true;
    }
    return false;
  }

  function getGuid() {
    var s = [];
    var hexDigits = "0123456789abcdef";
    for (var i = 0; i < 36; i++) {
        s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
    }
    s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
    s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
    s[8] = s[13] = s[18] = s[23] = "-";

    var uuid = s.join("");
    return uuid;
}

function getPsssengerName (pcode) {
  var pname = '成人';
  switch (pcode) {
      case 0:
      case "ADT":
          pname = '成人';
          break;
      case 1:
      case "CNN":
      case "CHD":
          pname = '儿童';
          break;
      case 2:
      case "INF":
          pname = '婴儿';
          break;
      case 3:
      case "OLD":
          pname = '老人';
          break;
      case 4:
      case "STU":
          pname = '学生';
          break;
      case 5:
      case "LBR":
          pname = '劳务';
          break;
      case 6:
      case "EMI":
          pname = '移民';
          break;
      case 7:
      case "SEA":
          pname = '海员';
          break;
      case 8:
      case "YNG":
          pname = '青年';
          break;
  }
  return pname;
}

//pagCodelist = [0,0,0,0,0,0,0,0];//乘客类型对应的乘客数量
function getPsssengerNameList(pagCodelist){
  var pagTypeNames = [];
  var pagTypeNameStr = "";
  if(pagCodelist && pagCodelist.length > 0){
      for (var index = 0; index < pagCodelist.length; index++) {
          if(pagCodelist[index] > 0){
            pagTypeNames.push({
              code:index,
              name:getPsssengerName(index),
              count:pagCodelist[index],
            });
          }
      }
  }

  if(pagTypeNames && pagTypeNames.length > 0){
    for (var index = 0; index < pagTypeNames.length; index++) {
      if(pagTypeNames[index] && pagTypeNames[index].count){
        if(pagTypeNameStr){
          pagTypeNameStr += '+' + pagTypeNames[index].count+'' + pagTypeNames[index].name;
        }
        else{
          pagTypeNameStr =  pagTypeNames[index].count+'' + pagTypeNames[index].name;
        }
      }
    }
  }
  return [pagTypeNames,pagTypeNameStr]; //[{code:0,name='成人',count:1}] , '1成人'
}