//飞行时长 短-长
function sortTotalDuration(data) {
  data.sort(function(a, b) {
    var aTime = a.totalDuration;
    var bTime = b.totalDuration;
    return aTime - bTime;
  });
  return data;
}

//起飞时间 早-晚
function sortStarttime(data) {
  data.sort(function(a, b) {
    var a_starttime = a.trips[0].departureDate + ' ' + a.trips[0].departureTime + ':00';
    var b_starttime = b.trips[0].departureDate + ' ' + b.trips[0].departureTime + ':00';
    a_starttime = a_starttime.replace(/-/g, '').replace(/:/g, '').replace(/\s/g, '');
    b_starttime = b_starttime.replace(/-/g, '').replace(/:/g, '').replace(/\s/g, '');
    return parseInt(a_starttime, 10) - parseInt(b_starttime, 10);
  });
  return data;
}

//到达时间 早-晚
function sortArrivetime(data) {
  data.sort(function(a, b) {
    var a_arrivetime = a.trips[0].arrivalDate + ' ' + a.trips[0].arrivalTime + ':00';
    var b_arrivetime = b.trips[0].arrivalDate + ' ' + b.trips[0].arrivalTime + ':00';
    a_arrivetime = a_arrivetime.replace(/-/g, '').replace(/:/g, '').replace(/\s/g, '');
    b_arrivetime = b_arrivetime.replace(/-/g, '').replace(/:/g, '').replace(/\s/g, '');
    return parseInt(a_arrivetime, 10) - parseInt(b_arrivetime, 10);
  });
  return data;
}

//价格 低-高
function sortFare(data,tax) {
  if (tax == "true") {
    data.sort(function(a, b) {
      if (a.psgFareArr[0].limit_final_fare === b.psgFareArr[0].limit_final_fare) {
        var aTime = a.totalDuration;
        var bTime = b.totalDuration;
        return  aTime - bTime;
      }else {
        return  a.psgFareArr[0].limit_final_fare - b.psgFareArr[0].limit_final_fare;
      }
    });
  } else {
    data.sort(function(a, b) {
      if (a.psgFareArr[0].limit_final_fare_without_tax === b.psgFareArr[0].limit_final_fare_without_tax) {
        var aTime = a.totalDuration;
        var bTime = b.totalDuration;
        return  aTime - bTime;
      }else {
        return  a.psgFareArr[0].limit_final_fare_without_tax - b.psgFareArr[0].limit_final_fare_without_tax;
      }
    });
  }

  return data;
}


//价格 低-高
function sortFareShare(data,tax,showModelObj) {
  if (tax == "true") {
    data.sort(function(a, b) {
      if (getShoppingPriceWithlimit_final_fare(a.psgFareArr[0],showModelObj) === getShoppingPriceWithlimit_final_fare(b.psgFareArr[0],showModelObj)) {
        var aTime = a.totalDuration;
        var bTime = b.totalDuration;
        return  aTime - bTime;
      }else {
        return  getShoppingPriceWithlimit_final_fare(a.psgFareArr[0],showModelObj) - getShoppingPriceWithlimit_final_fare(b.psgFareArr[0],showModelObj);
      }
    });
  } else {
    data.sort(function(a, b) {
      if (getShoppingPriceWithlimit_final_fare_without_tax(a.psgFareArr[0],showModelObj) === getShoppingPriceWithlimit_final_fare_without_tax(b.psgFareArr[0],showModelObj)) {
        var aTime = a.totalDuration;
        var bTime = b.totalDuration;
        return  aTime - bTime;
      }else {
        return  getShoppingPriceWithlimit_final_fare_without_tax(a.psgFareArr[0],showModelObj) - getShoppingPriceWithlimit_final_fare_without_tax(b.psgFareArr[0],showModelObj);
      }
    });
  }

  return data;
}

//直飞优先
function sortWay(data,tax) {
  if (tax == "true") {
    data.sort(function(a, b) {
      if (a.trips[0].transitTimes === b.trips[0].transitTimes) {
        var aFare = a.psgFareArr[0].limit_final_fare;
        var bFare = b.psgFareArr[0].limit_final_fare;
        return  aFare - bFare;
      }else {
        return  a.trips[0].transitTimes - b.trips[0].transitTimes;
      }
    });
  } else {
    data.sort(function(a, b) {
      if (a.trips[0].transitTimes === b.trips[0].transitTimes) {
        var aFare = a.psgFareArr[0].limit_final_fare_without_tax;
        var bFare = b.psgFareArr[0].limit_final_fare_without_tax;
        return  aFare - bFare;
      }else {
        return  a.trips[0].transitTimes - b.trips[0].transitTimes;
      }
    });
  }

  return data;
}

//直飞最低价格  中转最低价  飞行时间最少 区分是否含税
function minFlight(data,tax,sortIndex) {
  var dataDirect = [];//直飞
  var dataTransit = [];//中转
  var dataFlight = [];//飞行时间排序
  data.forEach(function(item) {
    item.minDirectFare = false;
    item.minTransitFare = false;
    item.minFlightTime = false;
    if (item.trips[sortIndex].transitTimes < 2) {
      dataDirect.push(item);
    }
    if (item.trips[sortIndex].transitTimes > 1) {
      dataTransit.push(item);
      // if (sortIndex > 0) {
      // 	console.log(item.trips[sortIndex].transitTimes);
      // 	console.log(JSON.stringify(dataTransit));
      // }
    }
    dataFlight.push(item);
  });


  dataDirect.sort(function(a, b) {
    if (tax == "true") {
        if (a.psgFareArr[0].limit_final_fare === b.psgFareArr[0].limit_final_fare) {
          var aTime = a.totalDuration;
          var bTime = b.totalDuration;
          return  aTime - bTime;
        }else {
          return  a.psgFareArr[0].limit_final_fare - b.psgFareArr[0].limit_final_fare;
        }
    } else {
        if (a.psgFareArr[0].limit_final_fare_without_tax === b.psgFareArr[0].limit_final_fare_without_tax) {
          var aTime = a.totalDuration;
          var bTime = b.totalDuration;
          return  aTime - bTime;
        }else {
          return  a.psgFareArr[0].limit_final_fare_without_tax - b.psgFareArr[0].limit_final_fare_without_tax;
        }
    }

  });
  if (dataDirect && dataDirect.length > 0) {
    dataDirect[0].minDirectFare = true;
  }

  dataTransit.sort(function(a, b) {
    if (tax == "true") {
        if (a.psgFareArr[0].limit_final_fare === b.psgFareArr[0].limit_final_fare) {
          var aTime = a.totalDuration;
          var bTime = b.totalDuration;
          return  aTime - bTime;
        }else {
          return  a.psgFareArr[0].limit_final_fare - b.psgFareArr[0].limit_final_fare;
        }
    } else {
        if (a.psgFareArr[0].limit_final_fare_without_tax === b.psgFareArr[0].limit_final_fare_without_tax) {
          var aTime = a.totalDuration;
          var bTime = b.totalDuration;
          return  aTime - bTime;
        }else {
          return  a.psgFareArr[0].limit_final_fare_without_tax - b.psgFareArr[0].limit_final_fare_without_tax;
        }
    }
  });
  if (dataTransit && dataTransit.length > 0) {
    dataTransit[0].minTransitFare = true;
  }

  dataFlight = sortTotalDuration(dataFlight);
  if (dataFlight && dataFlight.length > 0) {
    dataFlight[0].minFlightTime = true;
  }

  var isMinDirectFare = false;
  var isMinTransitFare = false;
  var isMinFlightTime = false;
  if (dataDirect && dataDirect.length == 0) {
    isMinDirectFare = true;
  }
  if (dataTransit && dataTransit.length == 0) {
    isMinTransitFare = true;
  }
  if (dataFlight && dataFlight.length == 0) {
    isMinFlightTime = true;
  }



  for (var i = 0; i < data.length; i++) {
    if (!isMinDirectFare) {
      for (var j = 0; j < dataDirect.length; j++) {
        if (dataDirect[j].minDirectFare && data[i].key == dataDirect[j].key) {
          data[i].minDirectFare = true;
          isMinDirectFare = true;
          break;
        }
      }
    }

    if (!isMinTransitFare) {
      for (var j = 0; j < dataTransit.length; j++) {
        if (dataTransit[j].minTransitFare && data[i].key == dataTransit[j].key) {
          data[i].minTransitFare = true;
          isMinTransitFare = true;
          break;
        }
      }
    }

    if (!isMinFlightTime) {
      for (var j = 0; j < dataFlight.length; j++) {
        if (dataFlight[j].minFlightTime && data[i].key == dataFlight[j].key) {
          data[i].minFlightTime = true;
          isMinFlightTime = true;
          break;
        }
      }
    }
    //存在即退出循环
    if (isMinTransitFare && isMinDirectFare && isMinFlightTime) {
      break;
    }

  }
  data = sortFare(data,tax);//再执行下才有显示
  return data;
}


//直飞最低价格  中转最低价  飞行时间最少 区分是否含税
function minFlightShare(data,tax,sortIndex,showModelObj) {
  var dataDirect = [];//直飞
  var dataTransit = [];//中转
  var dataFlight = [];//飞行时间排序
  data.forEach(function(item) {
    item.minDirectFare = false;
    item.minTransitFare = false;
    item.minFlightTime = false;
    if (item.trips[sortIndex].transitTimes < 2) {
      dataDirect.push(item);
    }
    if (item.trips[sortIndex].transitTimes > 1) {
      dataTransit.push(item);
      // if (sortIndex > 0) {
      // 	console.log(item.trips[sortIndex].transitTimes);
      // 	console.log(JSON.stringify(dataTransit));
      // }
    }
    dataFlight.push(item);
  });


  dataDirect.sort(function(a, b) {
    if (tax == "true") {
        if (getShoppingPriceWithlimit_final_fare(a.psgFareArr[0],showModelObj) === getShoppingPriceWithlimit_final_fare(b.psgFareArr[0],showModelObj)) {
          var aTime = a.totalDuration;
          var bTime = b.totalDuration;
          return  aTime - bTime;
        }else {
          return  getShoppingPriceWithlimit_final_fare(a.psgFareArr[0],showModelObj) - getShoppingPriceWithlimit_final_fare(b.psgFareArr[0],showModelObj);
        }
    } else {
        if (getShoppingPriceWithlimit_final_fare_without_tax(a.psgFareArr[0],showModelObj) === getShoppingPriceWithlimit_final_fare_without_tax(b.psgFareArr[0],showModelObj)) {
          var aTime = a.totalDuration;
          var bTime = b.totalDuration;
          return  aTime - bTime;
        }else {
          return  getShoppingPriceWithlimit_final_fare_without_tax(a.psgFareArr[0],showModelObj) - getShoppingPriceWithlimit_final_fare_without_tax(b.psgFareArr[0],showModelObj);
        }
    }

  });
  if (dataDirect && dataDirect.length > 0) {
    dataDirect[0].minDirectFare = true;
  }

  dataTransit.sort(function(a, b) {
    if (tax == "true") {
        if (getShoppingPriceWithlimit_final_fare(a.psgFareArr[0],showModelObj) === getShoppingPriceWithlimit_final_fare(b.psgFareArr[0],showModelObj)) {
          var aTime = a.totalDuration;
          var bTime = b.totalDuration;
          return  aTime - bTime;
        }else {
          return  getShoppingPriceWithlimit_final_fare(a.psgFareArr[0],showModelObj) - getShoppingPriceWithlimit_final_fare(b.psgFareArr[0],showModelObj);
        }
    } else {
        if (getShoppingPriceWithlimit_final_fare_without_tax(a.psgFareArr[0],showModelObj) === getShoppingPriceWithlimit_final_fare_without_tax(b.psgFareArr[0],showModelObj)) {
          var aTime = a.totalDuration;
          var bTime = b.totalDuration;
          return  aTime - bTime;
        }else {
          return  getShoppingPriceWithlimit_final_fare_without_tax(a.psgFareArr[0],showModelObj) - getShoppingPriceWithlimit_final_fare_without_tax(b.psgFareArr[0],showModelObj);
        }
    }
  });
  if (dataTransit && dataTransit.length > 0) {
    dataTransit[0].minTransitFare = true;
  }

  dataFlight = sortTotalDuration(dataFlight);
  if (dataFlight && dataFlight.length > 0) {
    dataFlight[0].minFlightTime = true;
  }

  var isMinDirectFare = false;
  var isMinTransitFare = false;
  var isMinFlightTime = false;
  if (dataDirect && dataDirect.length == 0) {
    isMinDirectFare = true;
  }
  if (dataTransit && dataTransit.length == 0) {
    isMinTransitFare = true;
  }
  if (dataFlight && dataFlight.length == 0) {
    isMinFlightTime = true;
  }



  for (var i = 0; i < data.length; i++) {
    if (!isMinDirectFare) {
      for (var j = 0; j < dataDirect.length; j++) {
        if (dataDirect[j].minDirectFare && data[i].key == dataDirect[j].key) {
          data[i].minDirectFare = true;
          isMinDirectFare = true;
          break;
        }
      }
    }

    if (!isMinTransitFare) {
      for (var j = 0; j < dataTransit.length; j++) {
        if (dataTransit[j].minTransitFare && data[i].key == dataTransit[j].key) {
          data[i].minTransitFare = true;
          isMinTransitFare = true;
          break;
        }
      }
    }

    if (!isMinFlightTime) {
      for (var j = 0; j < dataFlight.length; j++) {
        if (dataFlight[j].minFlightTime && data[i].key == dataFlight[j].key) {
          data[i].minFlightTime = true;
          isMinFlightTime = true;
          break;
        }
      }
    }
    //存在即退出循环
    if (isMinTransitFare && isMinDirectFare && isMinFlightTime) {
      break;
    }

  }
  data = sortFareShare(data,tax,showModelObj);//再执行下才有显示
  return data;
}



//返利优先  含税 OR 不含税 先按返利从大到小排列，费的值从小到大排列  返利含代理费+后返
function sortReward(data,tax) {
  data.sort(function(a, b) {
    //按返利-手续费 排序
    var aRebate = (a.th_psg_fares[0].limit_rebate_fare + a.th_psg_fares[0].commission_fare) - a.th_psg_fares[0].limit_fee;
    var bRebate = (b.th_psg_fares[0].limit_rebate_fare + b.th_psg_fares[0].commission_fare) - b.th_psg_fares[0].limit_fee;
    if (aRebate === bRebate) {
      var aFare = a.th_psg_fares[0].limit_rebate_fare + a.th_psg_fares[0].commission_fare;
      var bFare = b.th_psg_fares[0].limit_rebate_fare + b.th_psg_fares[0].commission_fare;
      return  aFare - bFare;
    }else {
      return  bRebate - aRebate;
    }
  });
  return data;
}

//过滤共享
function sortNotShare(data) {
  var dataNotShare = [];//过滤共享
  data.forEach(function(item) {
    if (!item.trips[0].isShareFligths) {
      dataNotShare.push(item);
    }
  });
  return dataNotShare;
}

//拿shopping处理后的价格  不含税结算价limit_final_fare_without_tax
function getShoppingPriceWithoutTax(priceObj,showModelObj) {
    //正常情况下 isIncludeService = true; isIncludeReward = false; addPrice = 0
    // 1 isIncludeService = true; isIncludeReward = true;  不要返利则+返利
    // 2 isIncludeService = false; isIncludeReward = false;  不要代理费则-代理费
    // 3 isIncludeService = false; isIncludeReward = true;  代理费和返利都不要
    // limit_final_fare_without_tax
    var returnPrice = priceObj.limit_final_fare_without_tax;

    if (showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice + (priceObj.limit_rebate_fare + priceObj.commission_fare) + showModelObj.addPrice;
    }
    else if (!showModelObj.isIncludeService && !showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.limit_fee + showModelObj.addPrice;
    }
    else if (!showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.limit_fee + (priceObj.limit_rebate_fare + priceObj.commission_fare) + showModelObj.addPrice;
    }
    else {
        returnPrice = returnPrice + showModelObj.addPrice;
    }
    return parseNum2(returnPrice);
}


//拿shopping处理后的价格  含税结算价limit_final_fare
function getShoppingPriceWithTax(priceObj,showModelObj) {
    //正常情况下 isIncludeService = true; isIncludeReward = false; addPrice = 0
    // 1 isIncludeService = true; isIncludeReward = true;  不要返利则+返利
    // 2 isIncludeService = false; isIncludeReward = false;  不要开票则-代理
    // 3 isIncludeService = false; isIncludeReward = true;  代理费和返利都不要
    // limit_final_fare
    var returnPrice = priceObj.limit_final_fare;//是含开票 含返利

    if (showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice + (priceObj.limit_rebate_fare + priceObj.commission_fare) + showModelObj.addPrice;//含开票 不含返利
    }
    else if (!showModelObj.isIncludeService && !showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.limit_fee + showModelObj.addPrice;//不含开票 含返利
    }
    else if (!showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.limit_fee + (priceObj.limit_rebate_fare + priceObj.commission_fare) + showModelObj.addPrice;//不含开票 不含返利
    }
    else {
        returnPrice = returnPrice + showModelObj.addPrice;//含开票 含返利
    }

    return parseNum2(returnPrice);
}


//拿shopping处理后的价格  base_fare 票面价
function getShoppingPriceWithBaseFare(priceObj,showModelObj) {
    //正常情况下 isIncludeService = true; isIncludeReward = false; addPrice = 0
    // 1 isIncludeService = true; isIncludeReward = true;   不显示返利 + 开票
    // 2 isIncludeService = false; isIncludeReward = false;  不显示代理费 - 返利
    // 3 isIncludeService = false; isIncludeReward = true;  扣除代理费和返利  都不显示
    // base_fare
    var returnPrice = priceObj.base_fare;

    if (showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice + priceObj.limit_fee + showModelObj.addPrice;
    }
    else if (!showModelObj.isIncludeService && !showModelObj.isIncludeReward) {
        returnPrice = returnPrice - (priceObj.limit_rebate_fare + priceObj.commission_fare) + showModelObj.addPrice;
    }
    else if (!showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice  + showModelObj.addPrice;
    }
    else {
        returnPrice = returnPrice + priceObj.limit_fee - (priceObj.limit_rebate_fare + priceObj.commission_fare) + showModelObj.addPrice ;
    }
    return parseNum2(returnPrice);
}


//拿pricing处理后的价格
function getPricingPriceWithBaseFare(priceObj,showModelObj) {
    //正常情况下 isIncludeService = true; isIncludeReward = false; addPrice = 0
    // 1 isIncludeService = true; isIncludeReward = true;   不显示返利 + 开票
    // 2 isIncludeService = false; isIncludeReward = false;  不显示代理费 - 返利
    // 3 isIncludeService = false; isIncludeReward = true;  扣除代理费和返利  都不显示
    var returnPrice = priceObj.salePrice;

    //PNR 计价 的有直减的处理  serviceFeeOld - pNR才有记录
    if (priceObj.smpcmoney && priceObj.serviceFeeOld) {
        returnPrice = returnPrice + priceObj.serviceFeeOld;
    }

    if (showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice + priceObj.serviceFee + showModelObj.addPrice;
    }
    else if (!showModelObj.isIncludeService && !showModelObj.isIncludeReward) {
        returnPrice = returnPrice - (priceObj.saleAfterReturnPrice + priceObj.saleBeforeReturnPrice) + showModelObj.addPrice;
    }
    else if (!showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice  + showModelObj.addPrice;
    }
    else {
        returnPrice = returnPrice + priceObj.serviceFee - (priceObj.saleAfterReturnPrice + priceObj.saleBeforeReturnPrice) + showModelObj.addPrice ;
    }
    return parseNum2(returnPrice);
}


//拿Pricing处理后的价格  不含税结算价limit_final_fare_without_tax
function getPricingPriceWithTax(priceObj,showModelObj) {
    //正常情况下 isIncludeService = true; isIncludeReward = false; addPrice = 0
    // 1 isIncludeService = true; isIncludeReward = true;  不要返利则+返利
    // 2 isIncludeService = false; isIncludeReward = false;  不要代理费则-代理费
    // 3 isIncludeService = false; isIncludeReward = true;  代理费和返利都不要
    // limit_final_fare_without_tax
    var returnPrice = priceObj.saleTotal;

    if (showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice + (priceObj.saleAfterReturnPrice + priceObj.saleBeforeReturnPrice) + showModelObj.addPrice;
    }
    else if (!showModelObj.isIncludeService && !showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.serviceFee + showModelObj.addPrice;
    }
    else if (!showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.serviceFee + (priceObj.saleAfterReturnPrice + priceObj.saleBeforeReturnPrice) + showModelObj.addPrice;
    }
    else {
        returnPrice = returnPrice + showModelObj.addPrice;
    }
    return parseNum2(returnPrice);
}


//拿Pricing处理后的价格  不含税结算价limit_final_fare_without_tax
function getPricingPriceWithoutTax(priceObj,showModelObj) {
    //正常情况下 isIncludeService = true; isIncludeReward = false; addPrice = 0
    // 1 isIncludeService = true; isIncludeReward = true;  不要返利则+返利
    // 2 isIncludeService = false; isIncludeReward = false;  不要代理费则-代理费
    // 3 isIncludeService = false; isIncludeReward = true;  代理费和返利都不要
    // limit_final_fare_without_tax
    var returnPrice = priceObj.saleTotal - priceObj.tax;

    if (showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice + (priceObj.saleAfterReturnPrice + priceObj.saleBeforeReturnPrice) + showModelObj.addPrice;
    }
    else if (!showModelObj.isIncludeService && !showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.serviceFee + showModelObj.addPrice;
    }
    else if (!showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.serviceFee + (priceObj.saleAfterReturnPrice + priceObj.saleBeforeReturnPrice) + showModelObj.addPrice;
    }
    else {
        returnPrice = returnPrice + showModelObj.addPrice;
    }
    return parseNum2(returnPrice);
}

//拿shopping处理后的价格  base_fare 票面价
function getShoppingPriceWithlimit_final_fare(priceObj,showModelObj) {
    //正常情况下 isIncludeService = true; isIncludeReward = false; addPrice = 0
    // 1 isIncludeService = true; isIncludeReward = true;   不显示返利 + 开票
    // 2 isIncludeService = false; isIncludeReward = false;  不显示开票费 - 返利
    // 3 isIncludeService = false; isIncludeReward = true;  扣除开票费和返利  都不显示
    // base_fare
    var returnPrice = priceObj.limit_final_fare;
    if (showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice + (priceObj.limit_rebate_fare + priceObj.commission_fare) + showModelObj.addPrice;//不含返利
    }
    else if (!showModelObj.isIncludeService && !showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.limit_fee + showModelObj.addPrice;//不含开票
    }
    else if (!showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.limit_fee + (priceObj.limit_rebate_fare + priceObj.commission_fare) + showModelObj.addPrice;//不含开票 不含返利
    }
    else {
        returnPrice = returnPrice + parseFloat(showModelObj.addPrice);//含开票 含返利
    }
    return parseNum2(returnPrice);
}

//拿shopping处理后的价格  base_fare 票面价  不含税
function getShoppingPriceWithlimit_final_fare_without_tax(priceObj,showModelObj) {
    //正常情况下 isIncludeService = true; isIncludeReward = false; addPrice = 0
    // 1 isIncludeService = true; isIncludeReward = true;   不显示返利 + 开票
    // 2 isIncludeService = false; isIncludeReward = false;  不显示开票费 - 返利
    // 3 isIncludeService = false; isIncludeReward = true;  扣除开票费和返利  都不显示
    // base_fare
    var returnPrice = priceObj.limit_final_fare_without_tax;
    if (showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice + (priceObj.limit_rebate_fare + priceObj.commission_fare) + showModelObj.addPrice;//不含返利
    }
    else if (!showModelObj.isIncludeService && !showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.limit_fee + showModelObj.addPrice;//不含开票
    }
    else if (!showModelObj.isIncludeService && showModelObj.isIncludeReward) {
        returnPrice = returnPrice - priceObj.limit_fee + (priceObj.limit_rebate_fare + priceObj.commission_fare) + showModelObj.addPrice;//不含开票 不含返利
    }
    else {
        returnPrice = returnPrice + parseFloat(showModelObj.addPrice);//含开票 含返利
    }

    return parseNum2(returnPrice);
}

//保留2位小数
function parseNum2(value){
  var _value = value;
  if(_value != 0 || _value != "0"){
    _value = parseFloat(parseFloat(value).toFixed(2))
  }
  return _value;
}
